# Acknowledgements {-}

I would like to thank the people who helped me during this project:

* Dr. Orestis Malaspinas, for his supervision and help on the project,
* Michaël El Kharroubi, for his help on the project,
* Dr. Troels Henriksen, for his answers to my questions about Futhark,
* Yann Sagon, for his answers to my questions about Baobab/Yggdrasil,
* Theo Pirkl, for the model of the bachelor thesis.

# Abstract {-}

Today, most computers are equipped with (+^GPU). They provide more and more computing cores and have become fundamental embedded high-performance computing tools. In this context, the number of applications taking advantage of these tools seems low at first glance. The problem is that the development tools are heterogeneous, complex, and strongly dependent on the (+GPU) running the code. Futhark is an experimental, functional, and architecture agnostic language; that is why it seems relevant to study it.  It allows generating code allowing a standard sequential execution (on a single-core processor), on (+GPU) (with (+CUDA) and (+OpenCL) backends), on several cores of the same processor (shared memory). To make it a tool that could be used on all high-performance platforms, it lacks support for distributed computing (+MPI). We create a library that distributes a cellular automaton on multiple compute nodes through (+MPI). The update of the cellular automaton is computed via the Futhark language using one of the four available backends (sequential, multicore, (+OpenCL), and (+CUDA)). In order to test our library, we implement a cellular automaton in one dimension ((+SCA)), in two dimensions (Game of Life), and three dimensions ((+LBM)). Finally, with the performance tests performed, we obtain an ideal speedup in one and two dimensions with the sequential and multicore backend, but with (+LBM), we obtain a maximum of x42 with 128 tasks. When using the GPU backends, we obtain an ideal speedup for the three cellular automata. Parallel computing shows better performance compared to sequential or concurrent computing. For example, with the Game of Life, we are up to 15 times faster.

\begin{figure} \vspace{.1cm} \begin{center} \includegraphics[scale=0.22]{figs/front-logo.png}
\end{center} \end{figure} 

\begin{table}[ht!]
\begin{tabular}{lllll}
Candidate:                                           & Referent teacher:               &  &  &  \\
\textbf{Baptiste COUDRAY}                            & \textbf{Dr. Orestis MALASPINAS} &  &  &  \\
Field of study: Information Technologies Engineering & \multicolumn{1}{r}{}            &  &  &  \\
&                                 &  &  &
\end{tabular}
\end{table}

\pagebreak
