\pagenumbering{arabic}

# Introduction {-}

Today, most computers are equipped with (+^GPU). They provide more and more computing cores and have become fundamental embedded high-performance computing tools. In this context, the number of applications taking advantage of these tools seems low at first glance. The problem is that the development tools are heterogeneous, complex, and strongly dependent on the (+GPU) running the code. Futhark is an experimental, functional, and architecture agnostic language; that is why it seems relevant to study it.  It allows generating code allowing a standard sequential execution (on a single-core processor), on (+GPU) (with (+CUDA) and (+OpenCL) backends), on several cores of the same processor (shared memory). To make it a tool that could be used on all high-performance platforms, it lacks support for distributed computing. This work aims to develop a library that can port any Futhark code to an (+MPI) library with as little effort as possible.

To achieve that, we introduce the meaning of distributed high-performance computing, then what is (+MPI) and Futhark. The (+MPI) specification allows doing distributed computing, and the programming language Futhark allows doing high-performance computing by compiling our program in (+OpenCL), (+CUDA), multicore, and sequential. We decide to implement a library that can distribute cellular automaton in, one, two or three dimensions. By adding Futhark on top of (+MPI), the programmer will have the possibilities to compile his code in:

* distributed-sequential mode,
* distributed-multicore mode,
* distributed-(+OpenCL) mode,
* distributed-(+CUDA) mode.

Finally, we used this library by implementing a cellular automata in each dimension:

* a (+SCA) in one dimension,
* the Game of Life in two dimensions,
* the (+LBM) in three dimensions.

We perform a benchmark to ensure that each cellular automata scales correctly in the four modes.

The leading resources we used to carry out this project were Futhark and (+MPI) user guide. We also exchanged with Futhark creator Troels Henriksen.

## Working method {-}

During this project, we use Git and put the source code on the Gitlab platform of (+HEPIA):

* Source code of the library with usage examples
  * https://gitedu.hesge.ch/baptiste.coudray/projet-de-bachelor
* Source code of this report
  * https://gitedu.hesge.ch/baptiste.coudray/projet-de-semestre/-/tree/report

\pagebreak
